#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>

#define MAX	5120

void main(int argc, char *argv[])
{
  long fs, pos;
  int handle;
  int nseg, seg, off;
  unsigned far *tick=(unsigned far *)0x0040006c;
  char *fn="fortunes.txt";
  char *buf=(char *)malloc(MAX);

  if (argc == 2) fn=argv[1];

  if ((handle=open(fn, O_RDONLY | O_BINARY)) == -1 ) {
	printf("\nFortune, copyleft by Neuron(KIM, JIN HONG), 1997-1-15, Corea made\n"\
		"\nusage: fortune file\n"\
		"\nWith no parameter, \"fortunes.txt\" is defaulted.\n"\
		"\nThis Fortune is capable of sharing a data of fortune in BSD(unix)\n"\
		"series specially. Because I used same data format. And the \"fortune.txt\" is\n"\
		"also copied from the FreeBSD's \"/usr/share/games/fortune/fortunes\".\n"\
		"\nMailto: s964524@ce.cecc.hallym.ac.kr\n");
	exit(1);
  }

  fs=filelength(handle);

  srand(*tick);

  // segmentation of file; the number of segment is determined by fs/32767(max +integer)
  // add 1 for not-segmented part, the rest of fs/32767
  nseg=fs/0x7fff;
  if ((fs % 0x7fff) > 0) nseg++;
  seg=random(nseg);
  if (seg+1 == nseg) off=random(fs % 0x7fff);
  else off=random(0x7fff);

  pos=(long)seg*0x7fff + off;

  lseek(handle, pos, SEEK_SET);
  read(handle, buf, MAX);

  // from now on, for code reduction...
  // nseg used as a counter variable.
  // seg used as a visible signal sign.
  nseg=0;   // reset counter
  seg=0;    // set to invisible

  while (1) {
	if (pos+nseg == fs) break;

	if (buf[nseg] == '%') {
	  if (seg) {
		buf[nseg]=NULL;     // make it a string
		break;
	  }

	  fn=&buf[nseg+1];  // 1 added to eliminate '%'
	  seg = (seg) ? (0) : (1);
	}

	nseg++;
  }

  printf(fn); // prints the fortune

  close(handle);
}
